// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMRAuto.pas' rev: 6.00

#ifndef SMRAutoHPP
#define SMRAutoHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SMRPars.hpp>	// Pascal unit
#include <SMPrntr.hpp>	// Pascal unit
#include <Grids.hpp>	// Pascal unit
#include <SMRTypes.hpp>	// Pascal unit
#include <PrintSM.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smrauto
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TImageAlign { iaTopPage, iaBottomPage, iaWholePage };
#pragma option pop

#pragma option push -b-
enum TBevels { bvNone, bvTopLine, bvBottomLine, bvLeftLine, bvRightLine, bvHCenterLine, bvVCenterLine, bvFrame };
#pragma option pop

#pragma option push -b-
enum TSMRRowStyle { rsNormal, rsPriceList, rsMSMoney, rsBrick, rsDesert, rsEggplant, rsLilac, rsMaple, rsMarine, rsRose, rsSpruce, rsWheat };
#pragma option pop

class DELPHICLASS TSMRStyle;
class PASCALIMPLEMENTATION TSMRStyle : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FFixedCols;
	bool FFixedRows;
	TSMRRowStyle FRowStyle;
	Graphics::TColor FOddColor;
	Graphics::TColor FEvenColor;
	void __fastcall SetRowStyle(TSMRRowStyle Value);
	
public:
	__fastcall virtual TSMRStyle(void);
	
__published:
	__property bool FixedCols = {read=FFixedCols, write=FFixedCols, nodefault};
	__property bool FixedRows = {read=FFixedRows, write=FFixedRows, nodefault};
	__property TSMRRowStyle RowStyle = {read=FRowStyle, write=SetRowStyle, nodefault};
	__property Graphics::TColor OddColor = {read=FOddColor, write=FOddColor, nodefault};
	__property Graphics::TColor EvenColor = {read=FEvenColor, write=FEvenColor, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMRStyle(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TOnDrawTextEvent)(Graphics::TCanvas* ACanvas, AnsiString &Text, const Types::TRect &ARect, Word &Flags);

class DELPHICLASS TSMAutoPrint;
class PASCALIMPLEMENTATION TSMAutoPrint : public Printsm::TSMPrintComponent 
{
	typedef Printsm::TSMPrintComponent inherited;
	
private:
	Classes::TStrings* FHeader;
	Graphics::TFont* FHeaderFont;
	Classes::TStrings* FFooter;
	Graphics::TFont* FFooterFont;
	Graphics::TPen* FGridLine;
	bool FWordWrap;
	char FMacroChar;
	TSMRStyle* FStyle;
	Smrtypes::TSMRHighLights* FHighLights;
	TOnDrawTextEvent FOnDrawText;
	void __fastcall SetHighLights(Smrtypes::TSMRHighLights* Value);
	void __fastcall SetStyle(TSMRStyle* Value);
	void __fastcall SetGridLine(Graphics::TPen* Value);
	void __fastcall SetMacroChar(char Value);
	bool __fastcall EvaluateMacro(AnsiString &strSource, Classes::TAlignment &FstrAlign, TBevels &bv, AnsiString &ImageFile, TImageAlign &ifAlign, bool IsPage);
	void __fastcall PrintBevel(TBevels bvlLine, int X1, int Y1, int X2, int Y2);
	void __fastcall SetHeader(Classes::TStrings* Value);
	void __fastcall SetHeaderFont(Graphics::TFont* Value);
	void __fastcall SetFooter(Classes::TStrings* Value);
	void __fastcall SetFooterFont(Graphics::TFont* Value);
	
protected:
	bool boolNeedPrintHeaderGrid;
	int __fastcall PrintStrings(Classes::TStrings* strList, Graphics::TFont* fontForPrint, bool boolCalc, bool IsPage);
	int __fastcall SMRDrawText(Graphics::TCanvas* ACanvas, AnsiString Text, const Types::TRect &ARect, Word Flags);
	
public:
	__fastcall virtual TSMAutoPrint(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMAutoPrint(void);
	virtual void __fastcall NewPage(bool isNewBar);
	__property Graphics::TPen* GridLine = {read=FGridLine, write=SetGridLine};
	
__published:
	__property TSMRStyle* Style = {read=FStyle, write=SetStyle};
	__property char MacroChar = {read=FMacroChar, write=SetMacroChar, nodefault};
	__property bool WordWrap = {read=FWordWrap, write=FWordWrap, nodefault};
	__property Classes::TStrings* Header = {read=FHeader, write=SetHeader};
	__property Graphics::TFont* HeaderFont = {read=FHeaderFont, write=SetHeaderFont};
	__property Classes::TStrings* Footer = {read=FFooter, write=SetFooter};
	__property Graphics::TFont* FooterFont = {read=FFooterFont, write=SetFooterFont};
	__property AnimatedStatus ;
	__property Frame ;
	__property PrinterSetting ;
	__property Smrtypes::TSMRHighLights* HighLights = {read=FHighLights, write=SetHighLights};
	__property OnGetVariable ;
	__property TOnDrawTextEvent OnDrawText = {read=FOnDrawText, write=FOnDrawText};
};


class DELPHICLASS TSMRACalculation;
class PASCALIMPLEMENTATION TSMRACalculation : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	Variant PrevValue;
	Variant CurValue;
	AnsiString FFieldName;
	Smrtypes::TSMRCalculation* FCalculation;
	Graphics::TFont* FFont;
	Classes::TAlignment FAlignment;
	bool FWordWrap;
	int FFieldColNum;
	AnsiString FCaption;
	int FCaptionColNum;
	void __fastcall SetFont(Graphics::TFont* Value);
	void __fastcall SetCalculation(Smrtypes::TSMRCalculation* Value);
	
public:
	__fastcall virtual TSMRACalculation(Classes::TCollection* Collection);
	__fastcall virtual ~TSMRACalculation(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall ValueChanged(void);
	
__published:
	__property AnsiString FieldName = {read=FFieldName, write=FFieldName};
	__property Smrtypes::TSMRCalculation* Calculation = {read=FCalculation, write=SetCalculation};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property int FieldColNum = {read=FFieldColNum, write=FFieldColNum, nodefault};
	__property int CaptionColNum = {read=FCaptionColNum, write=FCaptionColNum, nodefault};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=FAlignment, nodefault};
	__property bool WordWrap = {read=FWordWrap, write=FWordWrap, nodefault};
};


class DELPHICLASS TSMRACalculations;
class DELPHICLASS TSMPrintData;
#pragma option push -b-
enum TPrintRecNo { rnNone, rnFirstCol, rnFirstColOnEachBar };
#pragma option pop

#pragma option push -b-
enum TColumnSource { csDBGrid, csDataSet };
#pragma option pop

typedef void __fastcall (__closure *TSMRGetNextSelected)(System::TObject* Sender, int Index, void * &Selected);

typedef void __fastcall (__closure *TSMRGetSelectedCount)(System::TObject* Sender, int &Count);

class DELPHICLASS TSMRAGroup;
class PASCALIMPLEMENTATION TSMPrintData : public TSMAutoPrint 
{
	typedef TSMAutoPrint inherited;
	
private:
	int FRecNo;
	int FGapHorizontal;
	int FGapVertical;
	bool FIsWWDBGrid;
	bool FIsTMSDBGrid;
	Controls::TCustomControl* FDBGrid;
	Db::TDataSet* FDataSet;
	bool FSelectedRecord;
	TPrintRecNo FPrintRecNo;
	bool FAutoFit;
	TColumnSource FColumnSource;
	Classes::TList* FPosition;
	bool FWordWrapHeader;
	bool FBlankIfZero;
	TSMRACalculations* FCalculations;
	Classes::TList* Groups;
	int intStartColumn;
	int intEndColumn;
	int intMaxPageWidth;
	TSMRGetNextSelected FOnGetNextSelected;
	TSMRGetSelectedCount FOnGetSelectedCount;
	void __fastcall ReadCalculations(Classes::TReader* Reader);
	void __fastcall WriteCalculations(Classes::TWriter* Writer);
	void __fastcall SetCalculations(TSMRACalculations* Value);
	Controls::TCustomControl* __fastcall GetDBGrid(void);
	void __fastcall SetDBGrid(Controls::TCustomControl* AValue);
	Db::TDataSet* __fastcall GetDataSet(void);
	void __fastcall SetDataSet(Db::TDataSet* AValue);
	bool __fastcall PrintableField(Db::TField* Field);
	double __fastcall GetAutoFitCoef(void);
	int __fastcall GetMaxSize(bool boolWH, bool IsRecord, int intStart, int intEnd);
	int __fastcall GetMaxColumn(int intStart, int intPageWidth);
	void __fastcall FillColumnInfo(void);
	int __fastcall PrintHeaderGrid(int intMaxWidth);
	int __fastcall PrintRecord(int intMaxWidth, int intMaxHeight);
	int __fastcall GetGroupsMaxSize(void);
	int __fastcall PrintGroups(Db::TDataSet* ds, int intMaxWidth, int intMaxHeight);
	void __fastcall ClearGroups(void);
	void __fastcall AddGroup(TSMRACalculation* calc);
	void __fastcall FillGroups(void);
	TSMRAGroup* __fastcall GetGroup(AnsiString FieldName);
	bool __fastcall UpdateGroupValue(Db::TDataSet* ds, bool IsHeader);
	void __fastcall ResetGroupValue(void);
	void __fastcall ResetPrintedValues(Smrtypes::TResetType RType, AnsiString strGroupName);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	void * __fastcall GetNextSelected(int i);
	int __fastcall GetSelectedCount(void);
	AnsiString __fastcall GetFieldStr(Db::TField* curField);
	virtual void __fastcall PrepareReport(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	DYNAMIC TSMRACalculations* __fastcall CreateCalculations(void);
	
public:
	__fastcall virtual TSMPrintData(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMPrintData(void);
	virtual void __fastcall NewPage(bool isNewBar);
	__property bool IsWWDBGrid = {read=FIsWWDBGrid, nodefault};
	__property bool IsTMSDBGrid = {read=FIsTMSDBGrid, nodefault};
	
__published:
	__property TSMRACalculations* Calculations = {read=FCalculations, write=SetCalculations};
	__property bool BlankIfZero = {read=FBlankIfZero, write=FBlankIfZero, nodefault};
	__property int GapHorizontal = {read=FGapHorizontal, write=FGapHorizontal, nodefault};
	__property int GapVertical = {read=FGapVertical, write=FGapVertical, nodefault};
	__property GridLine ;
	__property Controls::TCustomControl* DBGrid = {read=GetDBGrid, write=SetDBGrid};
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property bool SelectedRecord = {read=FSelectedRecord, write=FSelectedRecord, nodefault};
	__property TPrintRecNo PrintRecNo = {read=FPrintRecNo, write=FPrintRecNo, nodefault};
	__property bool AutoFit = {read=FAutoFit, write=FAutoFit, nodefault};
	__property TColumnSource ColumnSource = {read=FColumnSource, write=FColumnSource, nodefault};
	__property bool WordWrapHeader = {read=FWordWrapHeader, write=FWordWrapHeader, nodefault};
	__property Font ;
	__property TSMRGetNextSelected OnGetNextSelected = {read=FOnGetNextSelected, write=FOnGetNextSelected};
	__property TSMRGetSelectedCount OnGetSelectedCount = {read=FOnGetSelectedCount, write=FOnGetSelectedCount};
};


class PASCALIMPLEMENTATION TSMRACalculations : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
public:
	TSMRACalculation* operator[](int Index) { return Items[Index]; }
	
private:
	TSMPrintData* FSMAReport;
	TSMRACalculation* __fastcall GetCalculation(int Index);
	void __fastcall SetCalculation(int Index, TSMRACalculation* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMRACalculations(TSMPrintData* SMRA);
	HIDESBASE TSMRACalculation* __fastcall Add(void);
	__property TSMPrintData* SMAReport = {read=FSMAReport};
	__property TSMRACalculation* Items[int Index] = {read=GetCalculation, write=SetCalculation/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TSMRACalculations(void) { }
	#pragma option pop
	
};


class DELPHICLASS TColumnInfo;
class PASCALIMPLEMENTATION TColumnInfo : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	AnsiString FieldName;
	AnsiString Caption;
	Classes::TAlignment Alignment;
	Classes::TAlignment HeaderAlignment;
	int Position;
	int Width;
	bool WordWrap;
	bool IsFixed;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TColumnInfo(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TColumnInfo(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TSMRAGroup : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	AnsiString FieldsList;
	Variant PrevValue;
	Variant CurValue;
	bool __fastcall ValueChanged(void);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRAGroup(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRAGroup(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMPrintCustomGrid;
class PASCALIMPLEMENTATION TSMPrintCustomGrid : public TSMAutoPrint 
{
	typedef TSMAutoPrint inherited;
	
private:
	int FGapHorizontal;
	int FGapVertical;
	bool FAutoFit;
	int intStartColumn;
	int intEndColumn;
	int intMaxPageWidth;
	double __fastcall GetAutoFitCoef(void);
	virtual int __fastcall GetMaxSize(bool boolWH, int intRow, int intStart, int intEnd);
	virtual int __fastcall GetMaxColumn(int intStart, int intPageWidth);
	virtual int __fastcall PrintHeaderGrid(int intMaxWidth);
	virtual int __fastcall PrintRow(int intRow, int intMaxWidth, int intMaxHeight);
	
protected:
	Classes::TList* FPosition;
	virtual bool __fastcall PrintHorizontalLines(void);
	virtual bool __fastcall PrintVerticalLines(void);
	virtual void __fastcall CheckAvailableGrid(void);
	virtual int __fastcall GetColCount(void);
	virtual int __fastcall GetRowCount(void);
	virtual int __fastcall GetFixedColCount(void);
	virtual int __fastcall GetFixedRowCount(void);
	virtual AnsiString __fastcall GetCellText(int Col, int Row);
	virtual Graphics::TFont* __fastcall GetControlFont(int Col, int Row);
	virtual void __fastcall FillColumnInfo(void);
	virtual void __fastcall PrepareReport(void);
	
public:
	__fastcall virtual TSMPrintCustomGrid(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMPrintCustomGrid(void);
	
__published:
	__property int GapHorizontal = {read=FGapHorizontal, write=FGapHorizontal, nodefault};
	__property int GapVertical = {read=FGapVertical, write=FGapVertical, nodefault};
	__property GridLine ;
	__property bool AutoFit = {read=FAutoFit, write=FAutoFit, nodefault};
};


class DELPHICLASS TSMPrintStringGrid;
class PASCALIMPLEMENTATION TSMPrintStringGrid : public TSMPrintCustomGrid 
{
	typedef TSMPrintCustomGrid inherited;
	
private:
	Grids::TStringGrid* FStringGrid;
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	virtual bool __fastcall PrintHorizontalLines(void);
	virtual bool __fastcall PrintVerticalLines(void);
	virtual void __fastcall CheckAvailableGrid(void);
	virtual int __fastcall GetColCount(void);
	virtual int __fastcall GetRowCount(void);
	virtual int __fastcall GetFixedColCount(void);
	virtual int __fastcall GetFixedRowCount(void);
	virtual AnsiString __fastcall GetCellText(int Col, int Row);
	virtual Graphics::TFont* __fastcall GetControlFont(int Col, int Row);
	virtual void __fastcall FillColumnInfo(void);
	
public:
	__fastcall virtual TSMPrintStringGrid(Classes::TComponent* AOwner);
	
__published:
	__property Grids::TStringGrid* StringGrid = {read=FStringGrid, write=FStringGrid};
public:
	#pragma option push -w-inl
	/* TSMPrintCustomGrid.Destroy */ inline __fastcall virtual ~TSMPrintStringGrid(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TCodePage { cpANSI, cpASCII };
#pragma option pop

class DELPHICLASS TSMPrintText;
class PASCALIMPLEMENTATION TSMPrintText : public TSMAutoPrint 
{
	typedef TSMAutoPrint inherited;
	
private:
	TCodePage FCodePage;
	AnsiString FFileName;
	int __fastcall PrintLine(AnsiString strForPrint, int intMaxWidth);
	int __fastcall GetStartChar(AnsiString str, int intMaxWidth);
	
protected:
	virtual void __fastcall PrepareReport(void);
	
public:
	__fastcall virtual TSMPrintText(Classes::TComponent* AOwner);
	
__published:
	__property TCodePage CodePage = {read=FCodePage, write=FCodePage, nodefault};
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property Font ;
public:
	#pragma option push -w-inl
	/* TSMAutoPrint.Destroy */ inline __fastcall virtual ~TSMPrintText(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE int AlignFlags[3];
extern PACKAGE Word WordWraps[2];
extern PACKAGE bool __fastcall PropIsDBGrid(Classes::TComponent* comp, bool &IsWWDBGrid, bool &IsTMSDBGrid);
extern PACKAGE Db::TDataSet* __fastcall GetPropAsDataSet(Classes::TComponent* comp);
extern PACKAGE Classes::TList* __fastcall GetPropAsSelectedList(Classes::TComponent* comp);
extern PACKAGE Classes::TCollection* __fastcall GetPropAsColumns(Classes::TComponent* comp);
extern PACKAGE Classes::TStrings* __fastcall GetPropAsSelected(Classes::TComponent* comp);
extern PACKAGE void __fastcall FillGridList(Classes::TComponent* comp, Classes::TStrings* lst);

}	/* namespace Smrauto */
using namespace Smrauto;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMRAuto
