program srpview;

uses
  Forms, Windows, Registry, PrintSM;

{$R *.RES}

procedure RegExtension;
begin
  with TRegIniFile.Create('') do
    try
      RootKey := HKEY_CLASSES_ROOT;
      if not KeyExists('.SRP') then
      begin
        WriteString('.SRP', '', 'SMReportPrepared');
        WriteString('SMReportPrepared', '', 'Prepared report forms of SMReport Designer');
        WriteString('SMReportPrepared\DefaultIcon', '', Application.ExeName + ', 0');
        WriteString('SMReportPrepared\Shell', '', 'Open');
        WriteString('SMReportPrepared\Shell\Open', '', 'Open report file');
        WriteString('SMReportPrepared\Shell\Open\command', '', Application.ExeName + ' %1');
        WriteString('SMReportPrepared\Shell\Print', '', 'Print report file');
        WriteString('SMReportPrepared\Shell\Print\command', '', Application.ExeName + ' /p %1');
      end
   finally
      Free;
   end;
end;

var
  s: string;
  IsPrint: Boolean;
begin
  Application.Initialize;

  {to register the file extension in Windows}
  RegExtension;
  IsPrint := False;

  with TSMPrintBaseComponent.Create(nil) do
    try
      Language.AutoDetect := True;

      if ParamCount > 0 then
      begin
        s := ParamStr(1);
        IsPrint := (s = '/p') or (s = '/P');
        if IsPrint then
          s := ParamStr(2);
        LoadPreparedReport(s);
      end;

      if IsPrint then
        Print
      else
        PreviewPreparedReport;
    finally
      Free;
    end;

  Application.Title := 'SMReport Designer''s viewer';
  Application.Run;
end.
